## mariadb-11.8-mroonga 15.22

=== debian/changelog ===
mariadb-11.8-mroonga (15.22-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Wed, 10 Dec 2025 03:21:08 -0000
