=== debian/control ===
Source: mariadb-11.8-mroonga
Section: database
Priority: optional
Maintainer: Horimoto Yasuhiro <horimoto@clear-code.com>
Build-Depends:
	bison,
	chrpath,
	cmake,
	debhelper (>= 13),
	dh-apparmor,
	gdb,
	groonga-normalizer-mysql,
	libaio-dev [linux-any],
	libboost-dev,
	libgroonga-dev (>= 11.0.0),
	libjemalloc-dev [linux-any],
	libjudy-dev,
	libmariadb-client-lgpl-dev-compat,
	libmariadbd-dev,
	libncurses5-dev,
	libpam0g-dev,
	libpcre2-dev,
	libpmem-dev,
	libreadline-dev,
	libsnappy-dev,
	libssl-dev,
	liburing-dev,
	libxml2-dev,
	lsb-release,
	ninja-build,
	perl,
	pkg-config,
	po-debconf,
	psmisc,
	unixodbc-dev,
	wget,
	zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://mroonga.org/

Package: mariadb-mroonga
Section: database
Architecture: any
Depends:
	mariadb-11.8-mroonga (= ${binary:Version}),
	mariadb-server (= 1:11.8.3-0+deb13u1)
Description: A fast fulltext searchable storage engine for MariaDB.
 This package is a metapackage depending on the latest version.
 Mroonga is a fast fulltext searchable storage engine for MariaDB.
 It is based on Groonga, a fast fulltext search engine and column store.
 Groonga is good at real time update.
 .
 This package provides a storage engine MariaDB 11.8 as a shared library.
 This provides "Mroonga" storage engine. It means you can use
 "ENGINE = Mroonga" in "CREATE TABLE".

Package: mariadb-11.8-mroonga
Section: database
Architecture: any
Depends:
	${misc:Depends},
	${shlibs:Depends},
	groonga-normalizer-mysql,
	libgroonga0 (>= 11.0.0),
	mariadb-server (= 1:11.8.3-0+deb13u1),
	mariadb-server-core (= 1:11.8.3-0+deb13u1)
Conflicts:
	mariadb-plugin-mroonga
Description: A fast fulltext searchable storage engine for MariaDB 11.8.
 Mroonga is a fast fulltext searchable storage engine for MariaDB.
 It is based on Groonga, a fast fulltext search engine and column store.
 Groonga is good at real time update.
 .
 This package provides a storage engine MariaDB 11.8 as a shared library.
 This provides "Mroonga" storage engine. It means you can use
 "ENGINE = Mroonga" in "CREATE TABLE".

Package: mariadb-11.8-mroonga-doc
Section: doc
Architecture: all
Depends:
	${misc:Depends}
Description: Documentation of Mroonga.
 Mroonga is a fast fulltext searchable storage engine for MariaDB.
 It is based on Groonga, a fast fulltext search engine and column store.
 Groonga is good at real time update.
 .
 This package provides documentation of Mroonga.
