## mariadb-11.8-mroonga 15.25

=== debian/changelog ===
mariadb-11.8-mroonga (15.25-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Fri, 06 Feb 2026 06:43:50 -0000
